Index: lib/simpletest/testoutputlib.php
=========================================================
--- lib/simpletest/testoutputlib.php	(revision 1.8)
+++ lib/simpletest/testoutputlib.php	Sat Jul 25 10:36:32 WST 2009
@@ -578,7 +578,7 @@
         $this->make_theme_template_dir('mytheme');
         $this->make_theme_template_dir('parenttheme');
         $this->make_theme_template_dir('standardtemplate');
-                
+
         // Exercise SUT.
         $factory = new testable_template_renderer_factory($theme, $this->page);
 
@@ -597,7 +597,7 @@
         $theme->parent = 'parenttheme';
         $this->make_theme_template_dir('mytheme');
         $this->make_theme_template_dir('standardtemplate');
-                
+
         // Exercise SUT.
         $factory    = new testable_template_renderer_factory($theme, $this->page);
         $subfactory = new testable_template_renderer_factory($theme, $this->page, 'subtype');
@@ -905,4 +905,135 @@
         $html = $this->renderer->error_text('');
         $this->assertEqual('', $html);
     }
+
+    public function test_link_to_popup_empty_link() {
+        // Empty link object: link MUST have a text value
+        $link = new html_link();
+        $popupaction = new popup_action('click', 'http://test.com', 'my_popup');
+        $link->add_action_object($popupaction);
+        $this->expectException();
+        $html = $this->renderer->link_to_popup($link);
+    }
+
+    public function test_link_to_popup() {
+        $link = new html_link();
+        $link->text = 'Click here';
+        $link->url = 'http://test.com';
+        $link->title = 'Popup window';
+        $popupaction = new popup_action('click', 'http://test.com', 'my_popup');
+        $link->add_action_object($popupaction);
+
+        $html = $this->renderer->link_to_popup($link);
+        $expectedattributes = array('title' => 'Popup window', 'href' => 'http://test.com');
+        $this->assert(new ContainsTagWithAttributes('a', $expectedattributes), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Click here'), $html);
+
+        // Try a different url for the link than for the popup
+        $link->url = 'http://otheraddress.com';
+        $html = $this->renderer->link_to_popup($link);
+
+        $this->assert(new ContainsTagWithAttribute('a', 'title', 'Popup window'), $html);
+        $this->assert(new ContainsTagWithAttribute('a', 'href', 'http://otheraddress.com'), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Click here'), $html);
+
+        // Give it a moodle_url object instead of a string
+        $link->url = new moodle_url('http://otheraddress.com');
+        $html = $this->renderer->link_to_popup($link);
+        $this->assert(new ContainsTagWithAttribute('a', 'title', 'Popup window'), $html);
+        $this->assert(new ContainsTagWithAttribute('a', 'href', 'http://otheraddress.com'), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Click here'), $html);
+
+    }
+
+    public function test_button() {
+        global $CFG;
+        $button = new html_button();
+        $button->label = 'Click Here';
+        $button->url = '/index.php';
+
+        $html = $this->renderer->button($button);
+        $this->assert(new ContainsTagWithAttribute('div', 'class', 'singlebutton'), $html);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => 'post', 'action' => $CFG->wwwroot . '/index.php')), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('type' => 'hidden', 'name' => 'sesskey', 'value' => sesskey())), $html);
+        $this->assert(new ContainsTagWithAttributes('input', array('value' => 'Click Here', 'type' => 'submit')), $html);
+
+        $button = new html_button();
+        $button->label = 'Click Here';
+        $button->url = '/index.php';
+        $button->confirmmessage = 'Are you sure?';
+
+        $html = $this->renderer->button($button);
+        $this->assert(new ContainsTagWithAttribute('div', 'class', 'singlebutton'), $html);
+        $this->assert(new ContainsTagWithAttributes('form', array('method' => 'post', 'action' => $CFG->wwwroot . '/index.php')), $html);
+        $this->assert(new ContainsTagWithAttribute('input', 'type', 'submit'), $html);
+
+        $button = new html_button();
+        $button->label = 'Click Here';
+        $button->url = '/index.php';
+        $button->url = new moodle_url($button->url, array('var1' => 'value1', 'var2' => 'value2'));
+        $html = $this->renderer->button($button);
+        $this->assert(new ContainsTagWithAttributes('input', array('name' => 'var1', 'type' => 'hidden', 'value' => 'value1')), $html);
+
+    }
+
+    public function test_link() {
+        $link = new html_link();
+        $link->url = 'http://test.com';
+        $link->text = 'Resource 1';
+
+        $html = $this->renderer->link($link);
+        $this->assert(new ContainsTagWithAttribute('a', 'href', 'http://test.com'), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Resource 1'), $html);
+
+        // Add a title
+        $link->title = 'Link to resource 1';
+        $html = $this->renderer->link($link);
+        $this->assert(new ContainsTagWithAttributes('a', array('title' => 'Link to resource 1', 'href' => 'http://test.com')), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Resource 1'), $html);
+
+        // Use a moodle_url object instead of string
+        $link->url = new moodle_url($link->url);
+        $html = $this->renderer->link($link);
+        $this->assert(new ContainsTagWithAttributes('a', array('title' => 'Link to resource 1', 'href' => 'http://test.com')), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Resource 1'), $html);
+
+        // Add a few classes to the link object
+        $link->add_classes('cool blue');
+        $html = $this->renderer->link($link);
+        $this->assert(new ContainsTagWithAttributes('a', array('title' => 'Link to resource 1', 'class' => 'link cool blue', 'href' => 'http://test.com')), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Resource 1'), $html);
+
+        // Simple use of link() without a html_link object
+        $html = $this->renderer->link($link->url->out(), $link->text);
+        $expected_html = '<a href="http://test.com">Resource 1</a>';
+        $this->assert(new ContainsTagWithAttribute('a', 'href', 'http://test.com'), $html);
+        $this->assert(new ContainsTagWithContents('a', 'Resource 1'), $html);
+
+        // Missing second param when first is a string: exception
+        $this->expectException();
+        $html = $this->renderer->link($link->url->out());
+    }
+
+    public function test_spacer() {
+        global $CFG;
+
+        $spacer = new html_image();
+
+        $html = $this->renderer->spacer($spacer);
+        $this->assert(new ContainsTagWithAttributes('img', array('class' => 'image spacer',
+                 'src' => $CFG->wwwroot . '/pix/spacer.gif',
+                 'alt' => ''
+                 )), $html);
+        $spacer = new html_image();
+        $spacer->src = $this->renderer->old_icon_url('myspacer');
+        $spacer->alt = 'sometext';
+        $spacer->add_class('my');
+
+        $html = $this->renderer->spacer($spacer);
+
+        $this->assert(new ContainsTagWithAttributes('img', array('class' => 'my image spacer',
+                 'src' => $this->renderer->old_icon_url('myspacer'),
+                 'alt' => 'sometext')), $html);
+
+    }
 }
Index: lib/simpletest/testweblib.php
=========================================================
--- lib/simpletest/testweblib.php	(revision 1.15)
+++ lib/simpletest/testweblib.php	Thu Jul 23 11:27:42 WST 2009
@@ -70,7 +70,7 @@
         $this->assertEqual(highlight('good', 'This is goodness'), 'This is <span class="highlight">good</span>ness');
     }
 
-    function test_replace_ampersands() { 
+    function test_replace_ampersands() {
         $this->assertEqual(replace_ampersands_not_followed_by_entity("This & that &nbsp;"), "This &amp; that &nbsp;");
         $this->assertEqual(replace_ampersands_not_followed_by_entity("This &nbsp that &nbsp;"), "This &amp;nbsp that &nbsp;");
     }
@@ -92,10 +92,29 @@
         $string = "visit http://www.moodle.org";
         convert_urls_into_links($string);
         $this->assertEqual($string, 'visit <a href="http://www.moodle.org">http://www.moodle.org</a>');
-        
+
         $string = "visit www.moodle.org";
         convert_urls_into_links($string);
         $this->assertEqual($string, 'visit <a href="http://www.moodle.org">www.moodle.org</a>');
     }
+
+    function test_prepare_url() {
+        global $CFG, $PAGE;
+        $fullexternalurl = 'http://www.externalsite.com/somepage.php';
+        $fullmoodleurl = $CFG->wwwroot . '/mod/forum/view.php?id=5';
+        $relativeurl1 = 'edit.php';
+        $relativeurl2 = '/edit.php';
+
+        $this->assertEqual($fullmoodleurl, prepare_url($fullmoodleurl));
+        $this->assertEqual($fullexternalurl, prepare_url($fullexternalurl));
+        $this->assertEqual("$CFG->wwwroot/admin/report/unittest/$relativeurl1", prepare_url($relativeurl1));
+        $this->assertEqual("$CFG->wwwroot$relativeurl2", prepare_url($relativeurl2));
+
+        // Use moodle_url object
+        $this->assertEqual($fullmoodleurl, prepare_url(new moodle_url('/mod/forum/view.php', array('id' => 5))));
+        $this->assertEqual($fullexternalurl, prepare_url(new moodle_url($fullexternalurl)));
+        $this->assertEqual("$CFG->wwwroot/admin/report/unittest/$relativeurl1", prepare_url(new moodle_url($relativeurl1)));
+        $this->assertEqual("$CFG->wwwroot$relativeurl2", prepare_url(new moodle_url($relativeurl2)));
+    }
 }
 ?>
Index: lib/simpletestlib.php
=========================================================
--- lib/simpletestlib.php	(revision 1.37)
+++ lib/simpletestlib.php	Fri Jul 24 19:36:09 WST 2009
@@ -256,13 +256,13 @@
             }
 
             $result = true;
-
+            
             foreach ($this->attributes as $attribute => $expectedvalue) {
-                if (!$node->attributes->getNamedItem($attribute)) {
+                if (!$node->getAttribute($attribute)) {
                     break 2;
                 }
                 
-                if ($node->attributes->getNamedItem($attribute)->value != $expectedvalue) {
+                if ($node->getAttribute($attribute) != $expectedvalue) {
                     $result = false;
                 }
             }
